--
--	JSHB Hunter Options - misdirection panel
--

if (select(2, UnitClass("player")) ~= "HUNTER") then return end

local L = _G.JSHB.L

function JSHB.Options:Panel_Misdirection(ord)
	local DB = _G.JSHB.Options.DB
	return {
		order = ord,
		type = "group",
		name = GetSpellInfo(34477),
		args = {
			spacer1 = { order = 1, type = "description", name = "", desc = "", width = "full" },
			enable = {
				type = "toggle",
				order = 2,
				name = L["Enable"],
				width = "full",
				get = function(info) return DB.misdirectionannounce.enable end,
				set = function(info, value) JSHB.Options:CollapseAll(); DB.misdirectionannounce.enable = value;JSHB.Options:LockDown(JSHB.SetupMisdirectionModule) end,
			},
			enablemdmountwarn = {
				order = 12,
				type = "toggle",
				name = L["Whisper target if mounted"],
				width = "double",
				disabled = function(info) return not DB.misdirectionannounce.enable end,
				get = function(info) return(DB.misdirectionannounce[info[#info] ]) end,
				set = function(info, value) DB.misdirectionannounce[info[#info] ] = (value);JSHB.Options:LockDown(JSHB.SetupMisdirectionModule) end,
			},
			spacer14 = { order = 14, type = "description", name = "", desc = "", width = "full" },
			solochan = {
				order = 16,
				type = "select",
				name = L["Solo"],
				desc = L["SOLOCHANNEL_DESC"],
				disabled = function(info) return not DB.misdirectionannounce.enable end,
				style = "dropdown",
				values = function() return(JSHB.chatChannels) end,
				get = function(info) return(DB.misdirectionannounce[info[#info] ]) end,
				set = function(info, value) DB.misdirectionannounce[info[#info] ] = (value);JSHB.Options:LockDown(JSHB.SetupMisdirectionModule) end,
			},
			partychan = {
				order = 18,
				type = "select",
				name = L["In a party"],
				desc = L["PARTYCHANNEL_DESC"],
				disabled = function(info) return not DB.misdirectionannounce.enable end,
				style = "dropdown",
				values = function() return(JSHB.chatChannels) end,
				get = function(info) return(DB.misdirectionannounce[info[#info] ]) end,
				set = function(info, value) DB.misdirectionannounce[info[#info] ] = (value);JSHB.Options:LockDown(JSHB.SetupMisdirectionModule) end,
			},
			raidchan = {
				order = 20,
				type = "select",
				name = L["In a raid"],
				desc = L["RAIDCHANNEL_DESC"],
				disabled = function(info) return not DB.misdirectionannounce.enable end,
				style = "dropdown",
				values = function() return(JSHB.chatChannels) end,
				get = function(info) return(DB.misdirectionannounce[info[#info] ]) end,
				set = function(info, value) DB.misdirectionannounce[info[#info] ] = (value);JSHB.Options:LockDown(JSHB.SetupMisdirectionModule) end,
			},
			arenachan = {
				order = 22,
				type = "select",
				name = L["In an arena"],
				desc = L["ARENACHANNEL_DESC"],
				disabled = function(info) return not DB.misdirectionannounce.enable end,
				style = "dropdown",
				values = function() return(JSHB.chatChannels) end,
				get = function(info) return(DB.misdirectionannounce[info[#info] ]) end,
				set = function(info, value) DB.misdirectionannounce[info[#info] ] = (value);JSHB.Options:LockDown(JSHB.SetupMisdirectionModule) end,
			},
			pvpchan = {
				order = 24,
				type = "select",
				name = L["In a PvP zone"],
				desc = L["PVPCHANNEL_DESC"],
				disabled = function(info) return not DB.misdirectionannounce.enable end,
				style = "dropdown",
				values = function() return(JSHB.chatChannels) end,
				get = function(info) return(DB.misdirectionannounce[info[#info] ]) end,
				set = function(info, value) DB.misdirectionannounce[info[#info] ] = (value);JSHB.Options:LockDown(JSHB.SetupMisdirectionModule) end,
			},
			spacer15 = { order = 25, type = "description", name = "", desc = "", width = "full" },
			clickenable = {
				type = "toggle",
				order = 26,
				name = L["Enable Right-Click to cast"],
				width = "full",
				get = function(info) return DB.misdirectionannounce.clickenable end,
				set = function(info, value) JSHB.Options:CollapseAll(); DB.misdirectionannounce.clickenable = value;JSHB.Options:LockDown(JSHB.SetupMisdirectionClickToCast) end,
			},
			fTARGET = {
				type = "toggle",
				order = 28,
				name = L["Target Frame"],
				width = "double",
				disabled = function(info) return (not DB.misdirectionannounce.clickenable) end,
				get = function(info) return(DB.misdirectionannounce[info[#info] ]) end,
				set = function(info, value) DB.misdirectionannounce[info[#info] ] = (value);JSHB.Options:LockDown(JSHB.SetupMisdirectionClickToCast) end,
			},
			fTOT = {
				type = "toggle",
				order = 30,
				name = L["Target of Target Frame"],
				disabled = function(info) return (not DB.misdirectionannounce.clickenable) end,
				get = function(info) return(DB.misdirectionannounce[info[#info] ]) end,
				set = function(info, value) DB.misdirectionannounce[info[#info] ] = (value);JSHB.Options:LockDown(JSHB.SetupMisdirectionClickToCast) end,
			},
			fFOCUS = {
				type = "toggle",
				order = 32,
				name = L["Focus Target Frame"],
				width = "double",
				disabled = function(info) return (not DB.misdirectionannounce.clickenable) end,
				get = function(info) return(DB.misdirectionannounce[info[#info] ]) end,
				set = function(info, value) DB.misdirectionannounce[info[#info] ] = (value);JSHB.Options:LockDown(JSHB.SetupMisdirectionClickToCast) end,
			},
			fPET = {
				type = "toggle",
				order = 34,
				name = L["Pet Frame"],
				disabled = function(info) return (not DB.misdirectionannounce.clickenable) end,
				get = function(info) return(DB.misdirectionannounce[info[#info] ]) end,
				set = function(info, value) DB.misdirectionannounce[info[#info] ] = (value);JSHB.Options:LockDown(JSHB.SetupMisdirectionClickToCast) end,
			},
			fPARTY = {
				type = "toggle",
				order = 36,
				name = L["Party Frames"],
				width = "double",
				disabled = function(info) return (not DB.misdirectionannounce.clickenable) end,
				get = function(info) return(DB.misdirectionannounce[info[#info] ]) end,
				set = function(info, value) DB.misdirectionannounce[info[#info] ] = (value);JSHB.Options:LockDown(JSHB.SetupMisdirectionClickToCast) end,
			},
			fPARTYPETS = {
				type = "toggle",
				order = 38,
				name = L["Party Pet Frames"],
				disabled = function(info) return (not DB.misdirectionannounce.clickenable) end,
				get = function(info) return(DB.misdirectionannounce[info[#info] ]) end,
				set = function(info, value) DB.misdirectionannounce[info[#info] ] = (value);JSHB.Options:LockDown(JSHB.SetupMisdirectionClickToCast) end,
			},
			fRAID = {
				type = "toggle",
				order = 40,
				name = L["Raid Frames"],
				width = "double",
				disabled = function(info) return (not DB.misdirectionannounce.clickenable) end,
				get = function(info) return(DB.misdirectionannounce[info[#info] ]) end,
				set = function(info, value) DB.misdirectionannounce[info[#info] ] = (value);JSHB.Options:LockDown(JSHB.SetupMisdirectionClickToCast) end,
			},
			fRAIDPET = {
				type = "toggle",
				order = 42,
				name = L["Raid Pet Frames"],
				disabled = function(info) return (not DB.misdirectionannounce.clickenable) end,
				get = function(info) return(DB.misdirectionannounce[info[#info] ]) end,
				set = function(info, value) DB.misdirectionannounce[info[#info] ] = (value);JSHB.Options:LockDown(JSHB.SetupMisdirectionClickToCast) end,
			},
			note = {
				type = "description",
				order = 50,
				name = L["MDCLICKNOTE"],
				desc = "",
				width = "full",
				hidden = function(info) return (not DB.misdirectionannounce.clickenable) end,
			},
		},
	}
end